﻿using System;

namespace Falcon.SugarApi.TimedTask
{
    /// <summary>
    /// 任务管理接口
    /// </summary>
    public interface ITaskManager
    {
        /// <summary>
        /// 任务名称
        /// </summary>
        string TaskName { get; }
        /// <summary>
        /// 任务说明
        /// </summary>
        string TaskDesc { get; }
        /// <summary>
        /// 任务计划
        /// </summary>
        string TaskSchedule { get; }
        /// <summary>
        /// 任务分组
        /// </summary>
        string? TaskGroup { get; }

        /// <summary>
        /// 上次运行时间
        /// </summary>
        DateTime? LastRunTime { get; }
        /// <summary>
        /// 上次运行信息
        /// </summary>
        public string? LastRunMessage { get; }

        /// <summary>
        /// 运行一次任务
        /// </summary>
        (bool isSuccess, string msg) RunOnce();
        /// <summary>
        /// 开始任务
        /// </summary>
        (bool isSuccess, string msg) StartTask();
        /// <summary>
        /// 停止任务
        /// </summary>
        (bool isSuccess, string msg) StopTask();
    }
}
